/*
 * Szegedi Tudományegyetem
 * Informatikai Tanszékcsoport
 * Szoftverfejlesztés Tanszék
 */

#ifndef PNM_TYPE_H
#define PNM_TYPE_H

typedef unsigned short int rgbpic_monochrome_pixel_t;
typedef unsigned short int rgbpic_picture_size_t;

typedef struct {
    rgbpic_monochrome_pixel_t red;
    rgbpic_monochrome_pixel_t green;
    rgbpic_monochrome_pixel_t blue;
} rgbpic_pixel_t;

typedef struct {
    rgbpic_monochrome_pixel_t maxpixvalue;
    rgbpic_picture_size_t width;
    rgbpic_picture_size_t height;
    rgbpic_pixel_t *pixelvalues;
} rgbpic_t;

static inline int rgbpic_coord(rgbpic_t *pic, rgbpic_picture_size_t x, rgbpic_picture_size_t y) {
    return  y * pic->width + x;
}

static inline rgbpic_monochrome_pixel_t rgbpic_rgb_to_gray(rgbpic_pixel_t p) {
    return (30 * p.red + 59 * p.green + 11 * p.blue) / 100;
}

rgbpic_t *rgbpic_load(const char*);
rgbpic_t *rgbpic_load_PBM(const char*);
rgbpic_t *rgbpic_load_PGM(const char*);
rgbpic_t *rgbpic_load_PPM(const char*);

int rgbpic_save_PBM(const char*, rgbpic_t*);
int rgbpic_save_PGM(const char*, rgbpic_t*);
int rgbpic_save_PPM(const char*, rgbpic_t*);

rgbpic_t *rgbpic_create(rgbpic_picture_size_t width, rgbpic_picture_size_t height, rgbpic_monochrome_pixel_t max);
void rgbpic_delete(rgbpic_t*);

#endif // PNM_TYPE_H
