/*
 * Szegedi Tudományegyetem
 * Informatikai Tanszékcsoport
 * Szoftverfejlesztés Tanszék
 */

#include "pnm-type.h"

#include <malloc.h>
#include <stdio.h>

/*
 * A main függvény.
 */
int main(int argc, char *argv[]) {
    rgbpic_t *kep;                              /* A kép (illetve a képre mutató pointer) */
    rgbpic_picture_size_t i, j;
    int szurke = 1, binary = 1;
    unsigned long long int iR = 0, iG = 0, iB = 0;
    if (argc < 2) {                                            /* Ha nincs elég paraméter */
        printf("Nincs elég paraméter!\n");
        return 1;
    }
    if (!(kep = rgbpic_load(argv[1]))) {  /* Az első paramétert input képként értelmezzük */
        printf("Nem sikerült megnyitni: %s\n", argv[1]);
        return 1;
    }
    printf("A képfájl neve: %s\n", argv[1]);
    printf("\tmérete: %hdx%hd pixel\n", kep->width, kep->height);
    for (i = 0; i < kep->height; ++i) {
        for (j = 0; j < kep->width; ++j) {
            rgbpic_monochrome_pixel_t r, g, b;
            iR += r = kep->pixelvalues[rgbpic_coord(kep, j, i)].red;
            iG += g = kep->pixelvalues[rgbpic_coord(kep, j, i)].green;
            iB += b = kep->pixelvalues[rgbpic_coord(kep, j, i)].blue;
            if (r != g || r != b) {
                szurke = binary = 0;
            }
            if (r != 0 && r != kep->maxpixvalue) {
                binary = 0;
            }
        }
    }
    if (binary) {
        printf("\tEz egy fekete-fehér bináris kép %llu%%-os átlagos szürke intenzitással.\n",
                    100llu * iR / (kep->width * kep->height * kep->maxpixvalue));
    } else if (szurke) {
        printf("\tEz egy szürkeárnyalatos kép %llu%%-os átlagos intenzitással.\n",
                    100llu * iR / (kep->width * kep->height * kep->maxpixvalue));
    } else {
        printf("\tEz egy színes kép (%llu%%, %llu%%, %llu%%)-os átlagos RGB,\n",
                    100llu * iR / (kep->width * kep->height * kep->maxpixvalue),
                    100llu * iG / (kep->width * kep->height * kep->maxpixvalue),
                    100llu * iB / (kep->width * kep->height * kep->maxpixvalue));
        printf("\tés %llu%%-os érték szerinti valamint %llu%%-os érzékelt szürke intenzitásokkal.\n",
                    100llu * (iR + iG + iB) / (3 * kep->width * kep->height * kep->maxpixvalue),
                    (30*iR + 59*iG + 11*iB) / (kep->width * kep->height * kep->maxpixvalue));
    }
    rgbpic_delete(kep);                                              /* Töröljük a képet. */
    return 0;
}
